#!/usr/bin/env python
#
# controller.py - Manages file-system access and calling of larchin scripts
#
# (c) Copyright 2010 Michael Towers (larch42 at googlemail dot com)
#
# This file is part of the larch project.
#
#    larch is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    larch is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with larch; if not, write to the Free Software Foundation, Inc.,
#    51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#
#----------------------------------------------------------------------------
#2010.08.15

import sys, os, __builtin__
from liblarch.rootrun import init_rootrun, runasroot
from liblarch.larcon_base import Backend
from liblarch.translation import i18n_module, lang

"""
import threading
from subprocess import call
try:
    import json as serialize
except:
    import simplejson as serialize

from config import *
"""




exports = {}
def add_exports(instance):
    """A simple mechanism to add fss functions. All the methods of the
    class instance which start with 'fss_' will be added to the available
    dictionary, so they can be called by fss('function-name', *args)
    [where 'function-name' is the function name without the 'fss_' prefix].
    All such functions should probably return json compatible results, to
    keep communication simple.
    """
    for attr in dir(instance):
        if attr.startswith('fss_'):
            exports[attr[4:]] = getattr(instance, attr)
__builtin__.add_exports = add_exports


def error0(message):
    sys.stderr.write('>>ERROR>>' + message + '\n')
    sys.stderr.flush()
__builtin__.error0 = error0



#TODO: the rest needs writing/modifying for larchin ...


class Fs(Backend):
    """Collect file system access methods in one class.
    """
    def __init__(self):
        Backend.__init__(self, 'larchin', globals())
        __builtin__._ = i18n_module(self.basedir, 'larchin')
        __builtin__.lang = lang




